<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalculatePricesRequest StructType
 * @subpackage Structs
 */
class CalculatePricesRequest extends AbstractCalculatePricesRequest
{
    /**
     * The policyData
     * @var \StructType\PolicyData
     */
    public $policyData;
    /**
     * The vehicleData
     * @var \StructType\VehicleData
     */
    public $vehicleData;
    /**
     * Constructor method for CalculatePricesRequest
     * @uses CalculatePricesRequest::setPolicyData()
     * @uses CalculatePricesRequest::setVehicleData()
     * @param \StructType\PolicyData $policyData
     * @param \StructType\VehicleData $vehicleData
     */
    public function __construct(\StructType\PolicyData $policyData = null, \StructType\VehicleData $vehicleData = null)
    {
        $this
            ->setPolicyData($policyData)
            ->setVehicleData($vehicleData);
    }
    /**
     * Get policyData value
     * @return \StructType\PolicyData|null
     */
    public function getPolicyData()
    {
        return $this->policyData;
    }
    /**
     * Set policyData value
     * @param \StructType\PolicyData $policyData
     * @return \StructType\CalculatePricesRequest
     */
    public function setPolicyData(\StructType\PolicyData $policyData = null)
    {
        $this->policyData = $policyData;
        return $this;
    }
    /**
     * Get vehicleData value
     * @return \StructType\VehicleData|null
     */
    public function getVehicleData()
    {
        return $this->vehicleData;
    }
    /**
     * Set vehicleData value
     * @param \StructType\VehicleData $vehicleData
     * @return \StructType\CalculatePricesRequest
     */
    public function setVehicleData(\StructType\VehicleData $vehicleData = null)
    {
        $this->vehicleData = $vehicleData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CalculatePricesRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
