<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PingResponse StructType
 * @subpackage Structs
 */
class PingResponse extends AbstractStructBase
{
    /**
     * The trackingId
     * @var string
     */
    public $trackingId;
    /**
     * The pong
     * @var string
     */
    public $pong;
    /**
     * Constructor method for PingResponse
     * @uses PingResponse::setTrackingId()
     * @uses PingResponse::setPong()
     * @param string $trackingId
     * @param string $pong
     */
    public function __construct($trackingId = null, $pong = null)
    {
        $this
            ->setTrackingId($trackingId)
            ->setPong($pong);
    }
    /**
     * Get trackingId value
     * @return string|null
     */
    public function getTrackingId()
    {
        return $this->trackingId;
    }
    /**
     * Set trackingId value
     * @param string $trackingId
     * @return \StructType\PingResponse
     */
    public function setTrackingId($trackingId = null)
    {
        // validation for constraint: string
        if (!is_null($trackingId) && !is_string($trackingId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($trackingId)), __LINE__);
        }
        $this->trackingId = $trackingId;
        return $this;
    }
    /**
     * Get pong value
     * @return string|null
     */
    public function getPong()
    {
        return $this->pong;
    }
    /**
     * Set pong value
     * @param string $pong
     * @return \StructType\PingResponse
     */
    public function setPong($pong = null)
    {
        // validation for constraint: string
        if (!is_null($pong) && !is_string($pong)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pong)), __LINE__);
        }
        $this->pong = $pong;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
