<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TariffGroupDiscount StructType
 * @subpackage Structs
 */
class TariffGroupDiscount extends AbstractStructBase
{
    /**
     * The tariffGroup
     * @var string
     */
    public $tariffGroup;
    /**
     * The difference
     * @var float
     */
    public $difference;
    /**
     * The differencePercentageAbs
     * @var int
     */
    public $differencePercentageAbs;
    /**
     * Constructor method for TariffGroupDiscount
     * @uses TariffGroupDiscount::setTariffGroup()
     * @uses TariffGroupDiscount::setDifference()
     * @uses TariffGroupDiscount::setDifferencePercentageAbs()
     * @param string $tariffGroup
     * @param float $difference
     * @param int $differencePercentageAbs
     */
    public function __construct($tariffGroup = null, $difference = null, $differencePercentageAbs = null)
    {
        $this
            ->setTariffGroup($tariffGroup)
            ->setDifference($difference)
            ->setDifferencePercentageAbs($differencePercentageAbs);
    }
    /**
     * Get tariffGroup value
     * @return string|null
     */
    public function getTariffGroup()
    {
        return $this->tariffGroup;
    }
    /**
     * Set tariffGroup value
     * @param string $tariffGroup
     * @return \StructType\TariffGroupDiscount
     */
    public function setTariffGroup($tariffGroup = null)
    {
        // validation for constraint: string
        if (!is_null($tariffGroup) && !is_string($tariffGroup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tariffGroup)), __LINE__);
        }
        $this->tariffGroup = $tariffGroup;
        return $this;
    }
    /**
     * Get difference value
     * @return float|null
     */
    public function getDifference()
    {
        return $this->difference;
    }
    /**
     * Set difference value
     * @param float $difference
     * @return \StructType\TariffGroupDiscount
     */
    public function setDifference($difference = null)
    {
        $this->difference = $difference;
        return $this;
    }
    /**
     * Get differencePercentageAbs value
     * @return int|null
     */
    public function getDifferencePercentageAbs()
    {
        return $this->differencePercentageAbs;
    }
    /**
     * Set differencePercentageAbs value
     * @param int $differencePercentageAbs
     * @return \StructType\TariffGroupDiscount
     */
    public function setDifferencePercentageAbs($differencePercentageAbs = null)
    {
        // validation for constraint: int
        if (!is_null($differencePercentageAbs) && !is_numeric($differencePercentageAbs)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($differencePercentageAbs)), __LINE__);
        }
        $this->differencePercentageAbs = $differencePercentageAbs;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TariffGroupDiscount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
